Friend Class formMain
    Inherits System.Windows.Forms.Form

    'fR[h͈͎wiformSetRectŐݒj
    Public blnEnableSetRect As Boolean = False
    Public intRectLeft As Integer = 0
    Public intRectTop As Integer = 0
    Public intRectRight As Integer = 0
    Public intRectBottom As Integer = 0

    'fR[hݒiformSetPropertyŐݒj
    Public intSymbolCount As Integer = 0
    Public intEffectLevel As Integer = 3
    Public byBorder As Byte = 0
    Public byModuleSize As Byte = 1

    Dim intFilterIndex As Short = 1 'sN`t@C

    Private Sub formMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        'eLXg{bNXNCAg̈ɍ킹B
        textDecodeResult.Width = ClientRectangle.Width
        textDecodeResult.Height = ClientRectangle.Height - MenuStrip1.Height

    End Sub

    Private Sub textDecodeResult_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles textDecodeResult.DragEnter

        't@Ĉ݃hbOhbv󂯕t
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If

    End Sub

    Private Sub textDecodeResult_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles textDecodeResult.DragDrop
        't@Chbv

        DecodeFile(e.Data.GetData(DataFormats.FileDrop)(0))

    End Sub

    Private Sub menuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuFileOpen.Click
        '[t@C]-[J]

        Dim openFileDialog1 As New OpenFileDialog()

        openFileDialog1.Filter = "sN` t@C (*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png)|*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png|" & _
                                 "rbg}bv t@C (*.bmp)|*.bmp|" & _
                                 "JPEG ` (*.jpg;*.jpeg)|*.jpg;*.jpeg|" & _
                                 "GIF ` (*.gif)|*.gif|" & _
                                 "TIFF ` (*.tif;*.tiff)|*.tif;*.tiff|" & _
                                 "PNG ` (*.png)|*.png|" & _
                                 "ׂẴt@C (*.*)|*.*"
        openFileDialog1.FilterIndex = intFilterIndex
        openFileDialog1.RestoreDirectory = True

        'R_CAOɂt@CI
        If openFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            intFilterIndex = openFileDialog1.FilterIndex
            DecodeFile(openFileDialog1.FileName)
        End If

    End Sub

    Private Sub menuAppExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuAppExit.Click
        'vOI

        Close()

    End Sub

    Private Sub menuSetDecodeRect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuSetDecodeRect.Click
        'fR[h͈͎w_CAO\

        formSetRect.ShowDialog() '[_\

    End Sub

    Private Sub menuSetDecodeProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuSetDecodeProperty.Click
        'fR[hݒ_CAO\

        formSetProperty.ShowDialog() '[_\

    End Sub

    Private Sub DecodeFile(ByVal strFilePath As String)
        '摜t@CΏۂƂfR[h

        'vJ[\\
        Cursor = System.Windows.Forms.Cursors.WaitCursor

        'DLLt@NVɂfR[h
        Dim intResult As Integer

        If blnEnableSetRect Then
            '͈͎w肠
            intResult = DecodePictureFileRect(strFilePath, intRectLeft, intRectTop, intRectRight, intRectBottom)
        Else
            '͈͎wȂ
            intResult = DecodePictureFile(strFilePath)
        End If

        'J[\
        Cursor = System.Windows.Forms.Cursors.Default

        Dim strResult As String = ""

        If intResult >= 1 Then
            'fR[hI

            Dim i As Integer

            For i = 0 To intResult - 1
                strResult = strResult & "" & vbCrLf

                'tH[}bg
                strResult = strResult & "fR[h f[^ " & Format(i + 1)
                strResult = strResult & " [^:" & Format(GetDecodeVersion(i))
                strResult = strResult & ", x:"

                Select Case GetDecodeLevel(i)
                    Case 0
                        strResult = strResult & "L(7%)"
                    Case 1
                        strResult = strResult & "M(15%)"
                    Case 2
                        strResult = strResult & "Q(25%)"
                    Case 3
                        strResult = strResult & "H(30%)"
                End Select

                'A
                Dim intCount As Integer
                Dim intSeqNo As Integer
                Dim byCheckDigit As Byte

                intCount = GetConcatenationInfo(i, intSeqNo, byCheckDigit)

                If intCount > 0 Then
                    strResult = strResult & ", A:" & Format(intSeqNo + 1) & "/" & Format(intCount)
                    strResult = strResult & "(CD:" & Hex(byCheckDigit \ &H10S) & Hex(byCheckDigit Mod &H10S) & "H)"
                End If

                strResult = strResult & "]" & vbCrLf
                strResult = strResult & "" & vbCrLf

                'V{f[^
                Dim strBuff As StringBuilder = New StringBuilder(7089)

                GetDecodeData(i, strBuff)

                strResult = strResult & strBuff.ToString & vbCrLf & vbCrLf

                'ʒu
                Dim intPosition(7) As Integer

                intResult = GetSymbolePosition(i, intPosition)

                strResult = strResult & "V{ʒuF" & _
                            "(" & Format(intPosition(0)) & ", " & Format(intPosition(1)) & ")-" & _
                            "(" & Format(intPosition(2)) & ", " & Format(intPosition(3)) & ")-" & _
                            "(" & Format(intPosition(4)) & ", " & Format(intPosition(5)) & ")-" & _
                            "(" & Format(intPosition(6)) & ", " & Format(intPosition(7)) & ")"

                strResult = strResult & vbCrLf & vbCrLf
            Next i

            'fR[hʕۑJ
            FreeAllocateMemory()

        Else
            'fR[hG[
            Select Case intResult

                Case QRD_ERROR_SYMBLE_NOT_FOUND
                    strResult = "QRR[h V{ǂݎ܂łB"

                    Select Case GetErrorLevel
                        Case 1
                            strResult = strResult + vbCrLf + "(ʒuop^[܂łB)"

                        Case 2
                            strResult = strResult + vbCrLf + "(ʒuop^[V{Fł܂łB)"

                        Case 3
                            strResult = strResult + vbCrLf + "(f[^̓ǂݎɎs܂B)"

                    End Select

                Case QRD_ERROR_FILE_NOT_FOUND
                    strResult = "t@C܂łB"

                Case QRD_ERROR_READ_FAULT
                    strResult = "t@CǂݍݒɃG[܂B"

                Case QRD_ERROR_BAD_FORMAT
                    strResult = "ǂݎłȂt@CʂłB"

                Case QRD_ERROR_SHARING_VIOLATION
                    strResult = "Lᔽɂt@Cǂݎ邱Ƃł܂łB"

                Case QRD_ERROR_NOT_ENOUGH_MEMORY
                    strResult = "słB"

            End Select
        End If

        textDecodeResult.Text = strResult

    End Sub

End Class